﻿
namespace LEDControl
{
    public class LEDApplicationMenu : LEDApplicationSelector
    {
        public override bool Start(LEDApplicationTree tree, LifecycleArgs args)
        {
            base.Start(tree, args);
            menuItemIndex = 0;
            return (tree.Children != null && tree.Children.Count > 0);
        }

        public override void Activate(LEDApplicationTree tree, LifecycleArgs args)
        {
            base.Activate(tree, args);
            args.LEDDevice.Write(tree.Children[menuItemIndex].Application.Name);
        }

        protected override int GetMaxChildren()
        {
            return int.MaxValue;
        }

        public override void OnButtonDown(LEDApplicationTree node, LEDDeviceButtonEventArgs args)
        {
            switch (args.Button)
            {
                // Exit launcher
                case Buttons.Button1:
                    RequestTerminate(args.Runner);
                    break;

                // Previous item in menu
                case Buttons.Button2:
                    if (--menuItemIndex < 0)
                        menuItemIndex = node.Children.Count - 1;
                    args.LEDDevice.Write(node.Children[menuItemIndex].Application.Name, ScrollOption.ScrollInFromLeft);
                    break;

                // Next item in menu
                case Buttons.Button3:
                    if (++menuItemIndex >= node.Children.Count)
                        menuItemIndex = 0;
                    args.LEDDevice.Write(node.Children[menuItemIndex].Application.Name, ScrollOption.ScrollInFromRight);
                    break;

                // Select current menu item
                case Buttons.Button4:
                    RequestExecute(args.Runner, node.Children[menuItemIndex]);
                    break;

                default:
                    base.OnButtonDown(node, args);
                    return;
            }

            args.Handled = true;
        }

        private int menuItemIndex;
    }
}
