﻿using System.Windows;
using System.Windows.Controls;

namespace LEDControl
{
    /// <summary>
    /// Interaction logic for LEDApplicationView.xaml
    /// </summary>
    public partial class LEDApplicationView : UserControl
    {
        public LEDApplicationView()
        {
            InitializeComponent();
        }

        /// <summary>
        /// When any piece of an application's tree view item (e.g. the application type
        /// combo box or the application name text box) gets focus, select the TreeViewItem
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ApplicationItem_GotFocus(object sender, RoutedEventArgs e)
        {
            DependencyObject dobj = (DependencyObject)sender;
            TreeViewItem tvi = dobj.GetAncestor<TreeViewItem>();
            if (tvi != null)
                tvi.IsSelected = true;
        }

        /// <summary>
        /// Change the type of application contained in a node
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ApplicationTypeComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ComboBox comboBox = (ComboBox)sender;
            LEDApplicationTreeViewModel ledApplicationTreeViewModel = (LEDApplicationTreeViewModel)comboBox.DataContext;
            string newTypeName = (string)comboBox.SelectedValue;

            ledApplicationTreeViewModel.ChangeApplicationType(newTypeName);

            comboBox.SelectedItem = ledApplicationTreeViewModel.Application.ApplicationType;
        }

        private void TreeView_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            LEDApplicationViewModel vm = (LEDApplicationViewModel) DataContext;
            vm.SelectedItem = e.NewValue as LEDApplicationTreeViewModel;
        }
    }
}
