﻿using System.Collections.ObjectModel;
using System.ComponentModel;

namespace LEDControl
{
    public class LEDApplicationViewModel : ViewModelBase
    {
        public LEDApplicationViewModel(LEDApplicationsModel model)
        {
            RootApplications = new ObservableCollection<LEDApplicationTreeViewModel>();
            model.PropertyChanged += delegate(object sender, PropertyChangedEventArgs e)
                                         {
                                             if (e.PropertyName == "RootApplication")
                                             {
                                                 RootApplications.Clear();
                                                 RootApplications.Add(new LEDApplicationTreeViewModel(model.RootApplication));
                                             }
                                         };
            RootApplications.Add(new LEDApplicationTreeViewModel(model.RootApplication));
        }

        public ObservableCollection<LEDApplicationTreeViewModel> RootApplications { get; private set; }

        private LEDApplicationTreeViewModel _selectedItem;
        public LEDApplicationTreeViewModel SelectedItem
        {
            get { return _selectedItem; }
            set { _selectedItem = value; OnPropertyChanged("SelectedItem"); }
        }
    }
}
